//--------------------------------------------------------------------------
// Death Ray, By DarkMagician
//--------------------------------------------------------------------------

datablock AudioProfile(DeathRaySwitchSound)
{
   filename    = "fx/misc/diagnostic_on.wav";
   description = AudioClosest3d;
   preload = true;
   effect = SniperRifleSwitchEffect;
};

datablock AudioProfile(DeathRayFireSound)
{
   filename    = "fx/misc/lightning_impact.wav";
   description = AudioClose3d;
   preload = true;
   effect = SniperRifleFireEffect;
};
datablock AudioProfile(DeathRayReloadSound)
{
   filename    = "fx/vehicles/bomber_bomb_reload.wav";
   description = AudioClose3d;
   preload = true;

};
datablock AudioProfile(DeathRayProjectileSound)
{
   filename    = "fx/powered/turret_aa_fire.wav";
   description = AudioClose3d;
   preload = true;
};

//--------------------------------------------------------------------------
// Explosion
//--------------------------------------
datablock AudioProfile(DeathRayExpSound)
{
   filename    = "fx/powered/turret_plasma_explode.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock ShockwaveData(DeathRayShockwave)
{
   width = 30;
   numSegments = 64;
   numVertSegments = 70;
   velocity = 50;
   acceleration = 50.0;
   lifetimeMS = 1000;
   height = 5.0;
   verticalCurve = 5.0;

   mapToTerrain = false;
   renderBottom = true;
   orientToNormal = true;

   texture[0] = "special/shockwave5";
   texture[1] = "special/gradient";
   texWrap = 3.0;

   times[0] = 0.1;
   times[1] = 5.0;
   times[2] = 10.5;

   colors[0] = "0.6 0.6 1.0 1.0";
   colors[1] = "0.6 0.3 1.0 0.5";
   colors[2] = "0.0 0.0 1.0 0.0";
};

datablock ExplosionData(DeathRayExplosion)
{
   explosionShape = "effect_plasma_explosion.dts";
   soundProfile   = DeathRayExpSound;
   shockwave      = DeathRayShockwave;
   faceViewer     = true;
};


//--------------------------------------
// Projectile
//--------------------------------------
datablock SniperProjectileData(DeathRayBeam)
{
   directDamage        = 1.25;
   velInheritFactor    = 1.0;
   faceViewer          = true;
   sound 			   = DeathRayProjectileSound;
   explosion           = "DeathRayExplosion";
   splash              = PlasmaSplash;
   directDamageType    = $DamageType::DeathRay;
   radiusDamageType    = $DamageType::DeathRay;

   maxRifleRange       = 100000;
   rifleHeadMultiplier = 5;
   beamColor           = "1 0 0.8";
   fadeTime            = 10.0;

   startBeamWidth		  =1.0;
   endBeamWidth 	     = 2.5;
   pulseBeamWidth 	  = 1.5;
   beamFlareAngle 	  = 30.0;
   minFlareSize        = 0.0;
   maxFlareSize        = 900.0;
   pulseSpeed          = 2.0;
   pulseLength         = 3.5;

   lightRadius         = 5.0;
   lightColor          = "1 0 0.8";

   textures[0] = "special/ELFBeam";
   textures[1] = "special/ELFLightning";
   textureName[0]      = "special/ELFBeam";
   textureName[1]      = "special/ELFLightning";
};

datablock TargetProjectileData(DeathRayLaserProjectile)
{
   directDamage        	= 0.0;
   hasDamageRadius     	= false;
   indirectDamage      	= 0.0;
   damageRadius        	= 0.0;
   velInheritFactor    	= 1.0;

   maxRifleRange       	= 100000;
   beamColor           	= "1 0 0.8";

   startBeamWidth			= 0.05;
   pulseBeamWidth 	   = 0.15;
   beamFlareAngle 	   = 3.0;
   minFlareSize        	= 0.0;
   maxFlareSize        	= 400.0;
   pulseSpeed          	= 6.0;
   pulseLength         	= 0.150;

   textureName[0]      	= "special/ELFLightning";
   textureName[1]      	= "special/flare";
   textureName[2]      	= "special/ELFBeam";
   textureName[3]      	= "special/flare";
};

datablock ItemData(DeathRay)
{
   className    = Weapon;
   catagory     = "Spawn Items";
   shapeFile    = "weapon_mortar.dts";
   image        = DeathRayImage;
   mass         = 1;
   elasticity   = 0.2;
   friction     = 0.6;
   pickupRadius = 2;
   pickUpName = "a Death Ray";
};

datablock ShapeBaseImageData(DeathRayImage)
{
	className = WeaponImage;
   shapeFile = "weapon_mortar.dts";
   item = DeathRay;
   projectile = DeathRayBeam;
   projectileType = SniperProjectile;
   offset = "0.20 -0.25 0.1";
   rotation = "0 1 0 180";
	usesEnergy = true;
	minEnergy = 25;

   stateName[0]                     = "Activate";
   stateTransitionOnTimeout[0]      = "ActivateReady";
   stateSound[0]                    = DeathRaySwitchSound;
   stateTimeoutValue[0]             = 0.5;
   stateSequence[0]                 = "Activate";

   stateName[1]                     = "ActivateReady";
   stateTransitionOnLoaded[1]       = "Ready";
   stateTransitionOnNoAmmo[1]       = "NoAmmo";

   stateName[2]                     = "Ready";
   stateTransitionOnNoAmmo[2]       = "NoAmmo";
   stateTransitionOnTriggerDown[2]  = "CheckWet";

   stateName[3]                     = "Fire";
   stateTransitionOnTimeout[3]      = "Reload";
   stateTimeoutValue[3]             = 1.5;
   stateFire[3]                     = true;
   stateAllowImageChange[3]         = false;
   stateSequence[3]                 = "Fire";
   stateScript[3]                   = "onFire";

   stateName[4]                     = "Reload";
   stateTransitionOnTimeout[4]      = "Ready";
   stateTimeoutValue[4]             = 3.0;
   stateSound[4]                    = DeathRayReloadSound;
   stateAllowImageChange[4]         = false;

   stateName[5]                     = "CheckWet";
   stateTransitionOnWet[5]          = "DryFire";
   stateTransitionOnNotWet[5]       = "Fire";

   stateName[6]                     = "NoAmmo";
   stateTransitionOnAmmo[6]         = "Reload";
   stateTransitionOnTriggerDown[6]  = "DryFire";
   stateSequence[6]                 = "NoAmmo";

   stateName[7]                     = "DryFire";
   stateSound[7]                    = ShockLanceDryFireSound;
   stateTimeoutValue[7]             = 0.5;
   stateTransitionOnTimeout[7]      = "Ready";
};

datablock ShapeBaseImageData(DeathRay2Image) : DeathRayImage
{
   shapefile="weapon_sniper.dts";
   offset = "0.1 -0.1 0.1";
   rotation ="0 1 0 -90";
};

datablock ShapeBaseImageData(DeathRay3Image) : DeathRayImage
{
   shapefile="weapon_sniper.dts";
   offset = "0.1 -0.1 0.1";
   rotation ="0 0 0 0";
};

datablock ShapeBaseImageData(DeathRay4Image) : DeathRayImage
{
   shapefile="weapon_sniper.dts";
   offset = "0.1 -0.1 0.1";
   rotation ="0 1 0 180";
};

datablock ShapeBaseImageData(DeathRay5Image) : DeathRayImage
{
   shapefile="weapon_sniper.dts";
   offset = "0.1 -0.1 0.1";
   rotation ="0 1 0 90";
};
datablock ShapeBaseImageData(DeathRay6Image) : DeathRayImage
{
   shapefile="weapon_sniper.dts";
   offset = "0.1 0.1 0.1";
   rotation ="0 1 0 90";
};
function DeathRayImage::onMount(%this,%obj,%slot)
{
   Parent::onMount(%this, %obj, %slot);
   CommandToClient(%obj.client, 'BottomPrint', "You are now using Dark's Evil Sinister DeathRay", 4, 2 );
   %obj.mountImage(DeathRay2Image, 4);
   %obj.mountImage(DeathRay3Image, 5);
   %obj.mountImage(DeathRay4Image, 6);
   %obj.mountImage(DeathRay5Image, 7);
}

function DeathRayImage::onUnmount(%this,%obj,%slot)
{
   Parent::onUnmount(%this, %obj, %slot);
   %obj.unmountImage(4);
   %obj.unmountImage(5);
   %obj.unmountImage(6);
   %obj.unmountImage(7);
}
function killit(%k)
{
     %k.delete();
}
function DeathRayImage::onFire(%data,%obj,%slot)
{

   %p = new (%data.projectileType)() {
      dataBlock        = %data.projectile;
      initialDirection = %obj.getMuzzleVector(%slot);
      initialPosition  = %obj.getMuzzlePoint(%slot);
      sourceObject     = %obj;
      damageFactor     = 5;
      sourceSlot       = %slot;
   };

   %obj.lastProjectile = %p;
   MissionCleanup.add(%p);
   serverPlay3D(DeathRayFireSound, %obj.getTransform());

   %t = new TargetProjectile()
   {
          dataBlock        = "DeathRayLaserProjectile";
          initialDirection = %obj.getMuzzleVector(%slot);
          initialPosition  = %obj.getMuzzlePoint(%slot);
          sourceObject     = %obj;
          sourceSlot       = %slot;
          vehicleObject    = 0;
   };
   MissionCleanup.add(%t);
   // AI hook
   if(%obj.client)
      %obj.client.projectile = %p;

   %obj.setEnergyLevel(%obj.getEnergyLevel() - 25);
   schedule(350, 0, "killit", %t);
}

